# -*- coding: utf-8 -*-
# Generated by Django 1.11.10 on 2019-01-22 19:24
from __future__ import unicode_literals

import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import model_utils.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='RawHit',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', model_utils.fields.AutoCreatedField(default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('modified', model_utils.fields.AutoLastModifiedField(default=django.utils.timezone.now, editable=False, verbose_name='modified')),
                ('user_id', models.TextField(blank=True)),
                ('session_id', models.TextField()),
                ('custom_metrics', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('custom_dimensions', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('session_custom_metrics', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('session_custom_dimensions', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('session_source', models.TextField(default='unknown')),
                ('session_medium', models.TextField(default='unkown')),
                ('hit_type', models.TextField(default='unkown')),
                ('event_category', models.TextField(blank=True)),
                ('event_action', models.TextField(blank=True)),
                ('event_label', models.TextField(blank=True)),
                ('event_value', models.IntegerField(null=True)),
                ('attribution_path', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('attribution', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('campaign_name', models.TextField(blank=True)),
                ('campaign_keyword', models.TextField(blank=True)),
                ('page_url', models.TextField(blank=True)),
                ('page_name', models.TextField(blank=True)),
                ('other_variables', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='User',
            fields=[
                ('created', model_utils.fields.AutoCreatedField(default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('modified', model_utils.fields.AutoLastModifiedField(default=django.utils.timezone.now, editable=False, verbose_name='modified')),
                ('cid', models.TextField(primary_key=True, serialize=False)),
                ('user_id', models.TextField(blank=True)),
                ('attribution_path', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('attribution', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('metrics', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('dimensions', django.contrib.postgres.fields.jsonb.JSONField(default=dict)),
                ('last_hit', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='djangoanalytics.RawHit')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='rawhit',
            name='cid',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='djangoanalytics.User'),
        ),
        migrations.AddIndex(
            model_name='rawhit',
            index=models.Index(fields=['event_category', '-created'], name='djangoanaly_event_c_e178ce_idx'),
        ),
        migrations.AddIndex(
            model_name='rawhit',
            index=models.Index(fields=['session_source', '-created'], name='djangoanaly_session_4826f3_idx'),
        ),
        migrations.AddIndex(
            model_name='rawhit',
            index=models.Index(fields=['-created'], name='djangoanaly_created_493d5c_idx'),
        ),
    ]
